// @ts-ignore
import axios from "axios";
// @ts-ignore
import Qs from "qs";

declare const window: any;

export const instance: any = axios.create();

export const get = async (url: any, params: any, headers = {}) => {
  const rsp = await instance({
    method: "GET",
    url,
    paramsSerializer: (params: any) => {
      return Qs.stringify(params, { arrayFormat: "repeat" });
    },
    params,
    headers,
    data: Qs.stringify(params, { indices: false }),
  }).catch(function (error: {
    config: any;
    response: { data: any; status: any; headers: any };
    responese: any;
    request: { toString: () => any };
    message: { toString: () => any };
  }) {
    console.log(error.config);
    if (error.response) {
      // The request was made and the server responded with a status code
      // that falls out of the range of 2xx
      console.log(error.response.data);
      console.log(error.response.status);
      console.log(error.response.headers);
      return error.response;
    } else if (error.request) {
      // The request was made but no response was received
      // `error.request` is an instance of XMLHttpRequest in the browser and an instance of
      // http.ClientRequest in node.js
      console.log(error.request);
      return {
        status: -2,
        data: { result: -2, message: error.request.toString() },
      };
    } else {
      // Something happened in setting up the request that triggered an Error
      console.log("Error", error.message);
      return {
        status: -3,
        data: { result: -3, message: error.message.toString() },
      };
    }
  });
  return [rsp.status === 200, rsp.data];
};

const isAudienceClient = () => {
  // return true
  if (!window.kinoJsApi) {
    return true;
  }
  return !!window.kinoJsApi.initPay;
};

function getArgNum(f: { toString: () => any }) {
  const code = f.toString();
  const aBegin = code.indexOf("(");
  if (aBegin < 0) {
    return 0;
  }
  const aEnd = code.indexOf(")", aBegin + 1);
  if (aEnd < 0) {
    return 0;
  }
  return code.substring(aBegin + 1, aEnd).split(",").length;
}

function shouldCallWrapApi() {
  if (!window.kinoJsApi) {
    return false;
  }
  if (!window.kinoJsApi.wrapApi) {
    return false;
  }
  const size = getArgNum(window.kinoJsApi.wrapApi);
  if (isAudienceClient() && size <= 3) {
    return false;
  }
  return true;
}

const wrapGet = function (path: any, params: { open_id: any; token: any }) {
  let callback: any;

  // @ts-ignore
  const p = new Promise((resolve: any) => {
    callback = resolve;
  });
  if (params.open_id !== undefined) {
    delete params.open_id;
  }
  if (params.token !== undefined) {
    delete params.token;
  }
  if (isAudienceClient()) {
    window.kinoJsApi.wrapApi("GET", path, params, callback);
  } else {
    window.kinoJsApi.wrapApi(path, params, callback);
  }
  return p;
};

export const wget = async (path: any, params: any) => {
  if (shouldCallWrapApi()) {
    let ret: any = {};
    try {
      ret = await wrapGet(path, params);
    } catch (e) {
      return [false, { result: -4, message: e.toStirng() }];
    }
    return [true, ret];
  } else {
    const ret = await get(path, params);
    return ret;
  }
};

const $http = {
  instance,
  get,
  wget,
};

export default $http;
